#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

littleboss	.equ	4

ShellTitle:
	.db "Galactix 86",0

;highscore data layout
; first 8 bytes = name or initials, next byte=0, next 2 bytes = score
; 5 slots=55 bytes
highscoretable:
	.text "Thomas W"
	.dw 500
number2
	.text "Thomas W"
	.dw 400
number3
	.text "Thomas W"
	.dw 300
number4
	.text "Thomas W"
	.dw 200
number5
	.text "Thomas W"
	.dw 100

ProgStart:
	call _runindicoff
	call _ram_page_1
	xor a
	ld (selector), a
galactixmenu:
	call clearscreen
galactixmenu2
	ld hl, GTitle
	ld de, $fc04
	ld b, 17
drawtitleloop:				;draw title screen
	push bc
	ld bc, 8
	push bc
	ldir
	pop bc
	ex de, hl
	add hl, bc
	ex de, hl
	pop bc
	djnz drawtitleloop
	ld hl, optionstring
	ld de, $1405
	ld c, 0
	call drawmenuopt
	ld d, $14+7
	call drawmenuopt
	ld d, $14+14
	call drawmenuopt
	ld d, $14+21
	call drawmenuopt
	ld de, $3201
	call drawstring
	ld de, $3810
	call drawstring
titleloop
	call _getky
	cp K_UP
	jr z, menuup
	cp K_DOWN
	jr z, menudown
	cp K_SECOND
	jr nz, titleloop
	ld a, (selector)
	or a
	jr z, playgame2
	cp 1
	call z, viewhighscores
	cp 2
	call z, viewacknowledgements
	cp 3
	ret z
	jp galactixmenu
menuup:
	ld a, (selector)
	dec a
finishmovemenu
	and 3
	ld (selector), a
	jp galactixmenu2
menudown
	ld a, (selector)
	inc a
	jr finishmovemenu

playgame2
	call playgame
	call waitkey
	ld hl, highscoretable+9				;check for a new high score
	ld b, 5
	ld de, (score)
cfanhslp:	;[c]heck [f]or [a] [n]ew [h]igh [s]core [l]oo[p]
	push bc
	push hl
	ld a, (hl)
	ld b, a
	inc hl
	ld a, (hl)
	cp d
	jr c, highscoreset
	jr z, checksame
	jr nextloopcfan
checksame:
	ld a, b
	cp e
	jr c, highscoreset
nextloopcfan:
	pop hl
	ld bc, 11
	add hl, bc
	pop bc
	djnz cfanhslp
	jp galactixmenu
highscoreset
	pop bc
	pop bc
	push hl
	push de
	ld a, b
	cp 1
	jr z, skipchangeplace
	ld hl, number4
	ld de, number5
	ld bc, 11
	ldir
	cp 2
	jr z, skipchangeplace
	ld hl, number3
	ld de, number4
	ld bc, 11
	ldir
	cp 3
	jr z, skipchangeplace
	ld hl, number2
	ld de, number3
	ld bc, 11
	ldir
	cp 4
	jr z, skipchangeplace
	ld hl, highscoretable
	ld de, number2
	ld bc, 11
	ldir
skipchangeplace:
	pop de
	pop hl
	ld (hl), d
	dec hl
	ld (hl), e
	ld b, 9
mhslp:
	dec hl
	djnz mhslp
	call changename
	ld hl,name-1
	rst 20h
	rst 10h
	ret c
	ex de,hl
	ld a,b
	call _load_ram_ahl
	out (5),a
	inc a
	out (6),a
	ld de,-16384+highscoretable-_asm_exec_ram+4
	add hl,de
	ex de,hl
	ld hl,highscoretable
	ld bc,55
	ldir
	ld a,$0d
	out (5),a
	call _ram_page_1
	jp galactixmenu

playgame:
	ld a, 255
	ld (wave), a
	ld a, 30
	ld (health), a
	ld a, 10
	ld (missilenum), a
	ld a, 2
	ld (bombnum), a
	ld hl, -100
	ld (score), hl
mainloop:
	ld hl, enemynum
	ld de, enemynum+1
	ld (hl), 0
	ld bc, 400				;clear all data
	ldir
	ld hl, wave
	inc (hl)
	ld a, (hl)
	cp 20
	jr c, notwave20yet
	ld a, (upgrade)
	or a
	jr nz, notwave20yet
	inc a
	ld (upgrade), a
notwave20yet:
	ld de, 100
	ld a, (hl)
	cp 21
	jr nz, not21wave
	ld de, 2300
not21wave
	ld hl, (score)
	add hl, de
	ld (score), hl
	ld hl, leveldata
	ld b, a
	ld d, 0
	or a
	jr z, skipgetwaveloop
getwaveloop:
	ld e,(hl)
	inc hl
	add hl, de
	djnz getwaveloop
skipgetwaveloop:
	ld a, (hl)
	ld (enemynum), a
	ld (maxenemynum), a
	ld de, enemydata
	ld b, a
setupenemies:
	push bc
	ld a, r
	and %00111111
	ld (de), a
	inc de
	ld a, r
	and %00011111
	inc a
	ld (de), a
	inc de
	ld a, r
	and %00111111
	inc a
	ld (de), a
	inc de
	inc hl
	ld a, (hl)
	push hl
	ld hl, healthdata
	ld c, a
	ld b, 0
	add hl, bc
	ld a, (hl)
	pop hl
	ld (de), a
	inc de
	ld a, (hl)
	ld (de), a
	inc de
	pop bc
	djnz setupenemies
	call loadsidebar
	call updatevars
	call opendoor
	ld a, 127
	ld (doorwait), a
gameloop
	ld hl, counter					;update counters
	inc (hl)
	inc hl
	ld a, (hl)
	add a, 9
	ld (hl), a
	ld a, (counter)
	and %01111111
	or a
	jr nz, noupdatehealth
	ld hl, health
	ld a, (hl)
	cp 30
	jr z, noupdatehealth
	inc (hl)
noupdatehealth:
	call drawgamescreen	
	call moveenemies
	call moveyourbullets
	call enemyshoot
	call moveenemybullets
	call moveupgrades
	call moveclaw
	call checkclaw
	call updateexplosions
	call movebomb
	ld a, (enemynum)
	cp 100
	jr nc, tempbugfix
	or a
	jr nz, nosubdoorwait
tempbugfix:
	ld a, (clawgot)
	cp 2
	jr nc, nosubdoorwait
	ld hl, doorwait
	dec (hl)
nosubdoorwait:
	ld a, (doorwait)
	or a
	jr z, nextwave
	ld a, (health)
	or a
	ret z
	ld b, 1
	call keyloop
	ld hl, shipx
	push af
	and %01000000
	call nz, goleft
	pop af
	push af
	and %00100000
	call nz, goright
	pop af
	push af
	and %00000100
	call nz, youshoot
	pop af
	push af
	and %00000010
	call nz, startclaw
	pop af
	push af
	and %10000000
	call nz, shootmissile
	pop af
	push af
	and %00010000
	call nz, deploybomb
	pop af
	push af
	and %00000001
	call nz, pause
	pop af
	and %00001000
	jp z, gameloop
	ret
nextwave:
	call closedoor
	ld a, (wave)
	cp 39					;if current wave is wave # 40 then we exit 
	ret nc
	jp mainloop

goleft
	ld a, (hl)
	cp 2
	ret z
	dec (hl)
	dec (hl)
	ret
goright:
	ld a, (hl)
	cp 74
	ret z
	inc (hl)
	inc (hl)
	ret

drawgamescreen:
	call clearscreen2
	call drawdoor
	ld hl, YShip1
	ld a, (upgrade)
	or a
	jr z, drawship
	ld hl, YShip2
	cp 1
	jr z, drawship
	ld hl, YShip3
drawship
	ld e, $3a
	ld a, (shipx)
	ld d, a
	call SPR16
	ld hl, enemydata
	ld a, (maxenemynum)
	ld b, a
drawenemyloop:
	inc hl
	push bc
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld a, (hl)
	inc hl
	ld b, (hl)
	inc hl
	or a
	jr z, noenemythere
	push hl
	push de
	ld l, b
	ld h, 0
	push hl						;save a
	add hl, hl					;hl=a*2
	add hl, hl					;hl=a*4
	push hl						;save a*4
	add hl, hl					;hl=a*8
	pop de						;de=a*4
	add hl, de					;hl=a*12
	pop de						;de=a
	add hl, de					;hl=a*13
	ld de, Enemy1
	add hl, de
	pop de
	call SPR16
	pop hl
noenemythere:
	pop bc
	djnz drawenemyloop
	ld hl, E1bullet				;draw enemy bullet type 1 (the rocket thing)
	ld de, bullet1
	ld b, 5
	call drawthebullet
	ld hl, E2bullet				;draw enemy bullet type 2 (the lightning thing)
	ld b, 5
	call drawthebullet
	ld hl, E3bullet				;draw enemy bullet type 3 (the spirally thing)
	ld b, 5
	call drawthebullet
	ld hl, E4bullet
	ld b, 5						;draw big boss bullet
	call drawthebullet				
	ld hl, YBullet1
	ld b, 8
	call drawthebullet
	ld hl, YBullet2
	ld b, 14					;mix both bullet types (same graphic)
	call drawthebullet
	ld hl, missile
	ld b, 1
	call drawthebullet
	ld hl, bomb
	ld b, 1
	call drawthebullet
	ld de, upxydata
	ld b, 8
drawupgradesloop:
	push bc
	push hl
	ld a, (de)
	ld b, a
	inc de
	ld a, (de)
	inc de
	ld c, a
	or a
	jr z, skipdrawupgrade
	ld a, b
	or a
	jr z, skipdrawupgrade
	push de
	ex de, hl
	ld a, (hl)
	add a, a
	add a, a
	add a, a
	add a, (hl)			;multiply by 9
	ld e, a
	ld d, 0
	ld hl, Mpack
	add hl, de
	ld e, b
	ld d, c
	call SPR8
	pop de
skipdrawupgrade
	inc de
	pop hl
	pop bc
	djnz drawupgradesloop
	ld a, (clawy)
	or a
	jr z, skipdrawclaw
	ld e, a
	ld a, (shipx)
	ld d, a
	inc d
	ld hl, Claw
	call SPR8
	ld a, (clawy)
	ld b, a
	ld a, 51
	sub b
	ld b, a
drawclawarmloop
	push bc
	ld a, (hl)
	or e
	ld (hl), a
	inc hl
	ld a, (hl)
	or d
	ld (hl), a
	ld bc, 10
	add hl, bc
	pop bc
	djnz drawclawarmloop
	ld a, (clawgot)
	cp 2
	jr c, skipdrawclaw
	ld hl, MPack
	dec a
	dec a
	ld b, a
	add a, a
	add a, a
	add a, a
	add a, b
	ld e, a
	ld d, 0
	add hl, de
	ld a, (clawy)
	dec a
	ld e, a
	ld a, (shipx)
	ld d, a
	inc d
	call SPR8
skipdrawclaw
	ld de, exdata
	ld b, 20
drawsfxloop:
	push bc
	push hl
	ld a, (de)
	ld b, a
	inc de
	ld a, (de)
	inc de
	ld c, a
	or a
	jr z, skipdrawexplode
	ld a, b
	or a
	jr z, skipdrawexplode
	push de
	ex de, hl
	ld a, (hl)
	add a, a
	add a, a
	add a, a
	sub (hl)			;multiply by 7
	ld e, a
	ld d, 0
	ld hl, explode0
	add hl, de
	ld e, b
	ld d, c
	call SPR8
	pop de
skipdrawexplode
	inc de
	pop hl
	pop bc
	djnz drawsfxloop
	call updatehealth
	jp copyscreen
drawthebullet:
	push bc
	push hl
	ld a, (de)
	ld b, a
	inc de
	ld a, (de)
	inc de
	ld c, a
	or a
	jr z, skipdrawbullet
	ld a, b
	or a
	jr z, skipdrawbullet
	push de
	ld e, b
	ld d, c
	call SPR8
	pop de
skipdrawbullet
	pop hl
	pop bc
	djnz drawthebullet
	ret

moveenemies:
	ld hl, enemydata
	ld a, (maxenemynum)
	ld b, a
moveenemyloop
	push bc
	push hl
	inc hl
	inc hl
	inc hl
	ld b, (hl)
	pop hl
	ld a, (counter)
	and %00000011
	ld c, a
	ld a, (hl)
	ld e, a
	inc hl
	inc hl
	ld a, b
	or a
	jr z, noenemyhere
	dec hl
	ld a, (hl)
	cp 1
	call z, changedirectiony1
	cp 36
	call z, changedirectiony2
	ld a, e
	and %00000111
	ld b, a
	call changepos
	inc hl
	ld a, (hl)
	cp 1
	call z, changedirectionx1
	cp 72
	call z, changedirectionx2
	ld a, e
	and %00111000
	rrca
	rrca
	rrca
	ld b, a
	call changepos
noenemyhere:
	inc hl
	inc hl
	inc hl
	pop bc
	djnz moveenemyloop
	ret

changepos:
	and %00000011
	cp c
	ret c
	push hl
	ld e, b
	ld d, 0
	ld hl, moveenemytable
	add hl, de
	ld b, (hl)
	pop hl
	ld a, (hl)
	add a, b
	ld (hl), a
	ret
changedirectiony1:
	inc (hl)
	jr cdirection
changedirectiony2:
	dec (hl)
cdirection:
	dec hl
	ld a, %00111000
	and (hl)
	ld (hl), a
	call getrandom
	and %00000111
	or (hl)
	ld (hl), a
	inc hl
	xor a
	ret
changedirectionx1:
	inc (hl)
	call cdirection2
	or %00100000
	ld (hl), a
	inc hl
	inc hl
	ret
changedirectionx2:
	dec (hl)
	call cdirection2
	and %00011000
	ld (hl), a
	inc hl
	inc hl
	ret
cdirection2:
	dec hl
	dec hl
	ld a, %00000111
	and (hl)
	ld (hl), a
	call getrandom
	and %00000111
	cp %00000110
	jr nz, nochange
	dec a
nochange
	rlca
	rlca
	rlca
	or (hl)
	ret
moveenemytable:
	.db -1, -1, -1, -1, 1, 1, 1, 1

youshoot:
	ld a, (counter)				;only 1/2 of moves
	and %00000001
	ret nz
	ld hl, yourbull1
	ld c, a
	ld b, 16					;if there are less than 4 zero's in the first bullet
yshtlp1:						;type data, then skip it (so you always shoot 2 at a time)
	ld a, (hl)
	or a
	jr nz, skipaddc
	inc c
skipaddc
	inc hl
	djnz yshtlp1
	ld a, c
	cp 4
	jr c, noaddybull1
	ld b, 8
	ld a, (shipx)
	inc a
	ld d, a
	ld e, 55
	ld hl, yourbull1
	call addbullet
	ld b, 8
	ld a, (shipx)
	add a, 8
	ld d, a
	ld e, 55
	ld hl, yourbull1
	call addbullet
noaddybull1
	ld a, (upgrade)
	or a
	ret z
	ld b, 7
	ld a, (shipx)
	add a, 4
	ld d, a
	ld e, 55
	ld hl, yourbull2
	call addbullet
	ld a, (upgrade)
	cp 1
	ret z
	ld b, 7
	ld a, (shipx)
	dec a
	dec a
	ld d, a
	ld e, 55
	ld hl, yourbull3
	call addbullet
	ld b, 7
	ld a, (shipx)
	add a, 10
	ld d, a
	ld e, 55
	ld hl, yourbull3
	call addbullet
	ret

enemyshoot:
	ld a, r
	inc a
	ld b, a
	ld a, (maxenemynum)
	cp b
	ret c
	ld hl, enemydata
getenemycoords:
	inc hl
	ld a, (hl)
	add a, 7
	ld e, a
	inc hl
	ld a, (hl)
	add a, 8
	ld d, a
	inc hl
	ld a, (hl)
	inc hl
	ld c, (hl)
	inc hl
	djnz getenemycoords
	or a
	ret z
	ld a, c
	cp 1
	jr z, make2bullet2
	ld hl, bullet3
	cp littleboss
	jr z, makebulletboss1
	cp 2
	jr z, werebullet3
	ld hl, bullet1
	or a
	jr z, werebullet3
	ld hl, bullet4
werebullet3:
	call addbullet2
	ret
make2bullet2:
	ld hl, bullet2
	push hl
	push de
	dec d
	dec d
	dec d
	call addbullet2
	pop de
	pop hl
	inc d
	inc d
	inc d
	jp addbullet2
makebulletboss1:
	ld hl, bullet3
	call addbullet2
	ld a, d
	sub 8
	ld d, a
	inc e
	inc e
	ld hl, bullet1
	call addbullet2
	ld a, d
	add a, 16
	ld d, a
	ld hl, bullet1
	call addbullet2
	inc e
	inc e
	ld a, d
	sub 8
	ld d, a
	jr make2bullet2

moveenemybullets:
	ld a, (counter)
	and 1
	ret z
	ld hl, bullet1
	ld b, 15
meblp1:
	ld a, (hl)
	or a
	jr z, skipmeblp1
	inc a
	cp 61
	call nc, makeme0
	ld (hl), a
skipmeblp1:
	inc hl
	inc hl
	djnz meblp1
	ld b, 5
meblp3:
	ld a, (hl)
	or a
	jr z, skipmeblp3
	inc a
	inc a
	inc a
	cp 61
	call nc, makeme0
	ld (hl), a
skipmeblp3:
	inc hl
	inc hl
	djnz meblp3
	ld a, (counter)
	and %00000010
	jr z, skipmovebullet3
	ld hl, bullet3
	ld a, (shipx)
	add a, 4
	ld c, a
	ld b, 10
meblp2:
	ld a, (hl)
	inc hl
	or a
	jr z, skipmeblp2
	ld a, (hl)
	cp c
	jr nc, doeffectx1
	inc a
	inc a
doeffectx1:
	dec a
	ld (hl), a
skipmeblp2
	inc hl
	djnz meblp2
skipmovebullet3:
	ld hl, bullet1
	ld a, (shipx)
	ld c, a
	ld b, 20				;check for collision with your ship
cfcwys:
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld a, e
	cp 55
	jr c, skipxcheck
	ld a, d
	sub c
	add a, 3
	cp 14
	jr nc, skipxcheck
	push hl
	push bc
	inc e
	call addexplosion
	pop bc
	pop hl
	ld a, b
	ld d, 3
	cp 16
	jr nc, thisisit
	ld d, 4
	cp 11
	jr nc, thisisit
	ld d, 6
	cp 6
	jr nc, thisisit
	ld d, 10
thisisit
	ld a, (health)
	sub d
	call c, make0
	ld (health), a
	cp 15
	jr nc, dontworryaboutlosingupgrade
	ld a, (upgrade)
	or a
	jr z, dontworryaboutlosingupgrade
	dec a
	ld (upgrade), a
dontworryaboutlosingupgrade
	xor a
	dec hl
	ld (hl), a
	dec hl
	ld (hl), a
	inc hl
	inc hl
skipxcheck:
	djnz cfcwys
	ret
make0:
	xor a
	ret

moveyourbullets:
	ld hl, yourbull1					;update y pos of bullet
	ld b, 8
myblp1:
	ld a, (hl)
	or a
	jr z, skipmyblp1
	sub 1								;go up 1 if bullet type 1
	call c, makeme0
	ld (hl), a
skipmyblp1:
	inc hl
	inc hl
	djnz myblp1
	ld hl, yourbull2
	ld b, 14
myblp2:
	ld a, (hl)
	or a
	jr z, skipmyblp2
	sub 2								;go up 2 if bullet type 2
	call c, makeme0
	ld (hl), a
skipmyblp2:
	inc hl
	inc hl
	djnz myblp2
	ld hl, mbull
	ld a, (hl)
	or a
	jr z, nomissiletomove
	sub 4
	call c, makeme0
	ld (hl), a
	ld e, a
	inc hl
	ld d, (hl)
	call addexplosion
nomissiletomove:
	ld hl, yourbull1					;check for collision with enemy
	ld b, 23
checkenemycollision
	push bc
	push hl
	pop ix					;may use it later
	ld a, b
	ld (missileon), a			;if current bullet is the missile, this equals 1
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld a, d
	add a, e
	or a
	jp z, skipthisbullet
	push hl
	ld hl, enemydata+1
	ld a, (maxenemynum)
	ld b, a
ceclp:
	ld a, (hl)
	ld c, a
	inc hl
	sub e
	add a, 8
	cp 8
	jr nc, nohit
	ld a, (hl)
	sub d
	add a, 16
	cp 16
	jr nc, nohit
	inc hl
	ld a, (hl)
	dec hl					;if enemy ship doesn't exist, then skip hit, too			
	or a
	jr z, nohit
;HIT!!!
	ld (ix+0), 0			;no more bullet
	ld (ix+1), 0
	inc hl
	ld a, (hl)				;update enemy health
	dec a
	ld (hl), a
	ld a, (missileon)
	cp 1
	call z, missilehit
	push hl
	dec e
	dec e
	dec e
	dec e
	dec e
	call addexplosion
	pop hl
	ld a, (hl)
	or a
	jr nz, wehitthem
	call killenemy
	ld l, c
	ld h, 0
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, hl
	ex de, hl
	ld hl, (score)
	add hl, de
	ld (score), hl
	call updatevars
	jr wehitthem
nohit
	inc hl
	inc hl
	inc hl
	inc hl
	dec b
	ld a, b
	or a
	jp nz, ceclp
wehitthem:
	pop hl
skipthisbullet:
	pop bc
	dec b				;equivalent to djnz (but long distance)
	ld a, b
	or a
	jp nz, checkenemycollision
	ret
makeme0:
	xor a
	inc hl
	ld (hl), a
	dec hl
	ret
missilehit:
	ld a, (hl)
	sub 20
	jr nc, nom0
	xor a
nom0
	ld (hl), a
	ret

moveupgrades
	ld hl, upxydata
	ld b, 8
mugloop:
	ld a, (hl)
	inc hl
	or a
	jr z, skipmug
	ld a, (counter)
	and 15
	jr nz, skipmoveupup
	dec hl
	dec (hl)
	inc hl
skipmoveupup
	ld a, (hl)
	cp 3
	jr c, skipmug
	cp 78
	jr nc, skipmug
	ld c, a
	ld a, r
	and %00000011
	cp 3
	jr z, skipmug
	dec a
	add a, c
	ld (hl), a
skipmug:
	inc hl
	inc hl
	djnz mugloop
	ret

startclaw
	ld hl, clawy
	ld a, (hl)
	or a
	ret nz
	ld (hl), 50
	inc hl
	ld (hl), 0
	ret

checkclaw:
	ld a, (clawy)
	or a
	ret z
	ld hl, upxydata
	ld b, 8
cclawloop:
	push bc
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld a, e
	or a
	jr z, notintercept
	ld a, (shipx)
	sub d
	add a, 8
	cp 15
	jr nc, notintercept
	ld a, (clawy)
	sub e
	add a, 8
	cp 15
	jr nz, notintercept
;INTERCEPT!
	ld a, (hl)
	add a, 2
	ld (clawgot), a
	xor a
	ld (hl), a
	dec hl
	ld (hl), a
	dec hl
	ld (hl), a
	pop bc
	ret
notintercept
	inc hl
	pop bc
	djnz cclawloop
	ret

moveclaw
	ld hl, clawy
	ld a, (hl)
	or a
	ret z
	inc hl
	ld a, (hl)
	or a
	jr nz, movingdown
	dec hl
	ld a, (hl)
	dec a
	or a 
	jr z, moveondownnow
	ld (hl), a
	ret
moveondownnow
	inc hl
	inc (hl)
movingdown
	dec hl
	ld a, (hl)
	cp 51
	jr z, clawdone
	inc (hl)
	ret
clawdone
	ld (hl), 0
	inc hl
	ld a, (hl)
	ld (hl), 0
	ld l, a
	ld h, 0
	add hl, hl
	add hl, hl
	add hl, hl
	ex de, hl
	ld hl, (score)
	add hl, de
	ld (score), hl
	cp 1
	ret z
	cp 2
	jr z, addmissile
	cp 3
	jr z, addbomb
	cp 4
	jr z, addenergy
	ld a, (upgrade)
	cp 2
	ret z
	inc a
	ld (upgrade), a
	jp updatevars
addmissile
	ld hl, missilenum
	inc (hl)
	inc (hl)
	inc (hl)
	jp updatevars
addbomb
	ld hl, bombnum
	inc (hl)
	jp updatevars
addenergy
	ld a, 24
	ld (health), a
	jp updatevars

shootmissile
	ld a, (mbull)
	or a
	ret nz
	ld hl, missilenum
	ld a, (hl)
	or a
	ret z
	dec (hl)
	ld a, (shipx)
	dec a
	ld (mbull+1), a
	ld a, 54
	ld (mbull), a
	jp updatevars

deploybomb
	ld a, (bbull)
	or a
	ret nz
	ld hl, bombnum
	ld a, (hl)
	or a
	ret z
	dec (hl)
	ld a, (shipx)
	dec a
	ld (bbull+1), a
	ld a, 54
	ld (bbull), a
	jp updatevars

movebomb:
	ld a, (counter)
	and 3
	ret nz
	ld hl, bbull
	ld a, (hl)
	or a
	ret z
	inc hl
	ld a, (hl)
	cp 44
	jr nc, decreasebomb
	inc (hl)
	inc (hl)
decreasebomb
	dec (hl)
	dec hl
	dec (hl)
	ld a, (hl)
	cp 25
	jr z, bombblow
	ret
bombblow
	ld e, a
	xor a
	ld (hl), a
	inc hl
	ld d, (hl)
	ld (hl), a
	call addexplosion
	ld hl, enemydata+1
	ld a, (maxenemynum)
	ld b, a
loseenemyhealth
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld a, e
	or a
	jr z, noenemytobomb
	ld a, d
	or a
	jr z, noenemytobomb
	push hl
	push bc
	call addexplosion
	inc d
	inc d
	inc d
	inc d
	dec e
	dec e
	ld a, r
	and %00000011
	add a, e
	ld e, a
	call addexplosion
	pop bc
	pop hl
	ld a, (hl)
	sub 30
	jr nc, nokillbybomb
	push bc
	push hl
	call killenemy
	pop hl
	pop bc
	xor a
nokillbybomb
	ld (hl), a
noenemytobomb
	inc hl
	inc hl
	inc hl
	djnz loseenemyhealth
	ret
	
updateexplosions:
	ld a, (counter)
	and 1
	ret z
	ld hl, exdata
	ld b, 20
updateexplosionsloop:
	ld a, (hl)
	inc hl
	inc hl
	ld c, (hl)
	inc hl
	or a
	jr z, nextexplosion
	ld a, c
	dec hl
	inc a
	cp 8
	jr nz, noclearexplosion
	xor a
	dec hl
	ld (hl), a
	dec hl
	ld (hl), a
	inc hl
	inc hl
noclearexplosion
	ld (hl), a
	inc hl
nextexplosion
	djnz updateexplosionsloop
	ret

killenemy
	inc hl
	ld c, (hl)
	dec hl
	dec hl					;kill enemy
	ld d, (hl)
	ld (hl), a
	dec hl
	ld e, (hl)
	ld (hl), a
	ld hl, enemynum
	dec (hl)
	ld hl, upxydata
	ld b, 8
	ld a, c
	cp littleboss
	jr z, addupgrade
	ld a, r				;add upgrade? 1/4
	and %00000011
	ret nz
addupgrade:
	ld a, (hl)
	or a
	jr nz, doloopagian2
	ld (hl), e
	inc hl
	ld (hl), d
	inc hl
	ld a, (counter)			;<---technically this is 'random'
	inc a
	ld (counter), a
	and 1
	ld b, a
	ld a, (health)
	cp 10
	jr nc, notenergyupgrade
	inc b
notenergyupgrade
	ld a, c
	cp littleboss
	jr nz, notbigbossupgrade
	ld b, 3
notbigbossupgrade
	ld (hl), b
	ret
doloopagian2:
	inc hl
	inc hl
	inc hl
	djnz addupgrade
	ret

viewhighscores
	call drawhighscores
	call pause
	xor a
	ret

drawhighscores:
	call clearscreen
	ld hl, highscorestring1
	ld de, $0110
	call drawstring
	ld de, $0a01
	call drawstring
	ld d, $12
	call drawstring
	ld d, $1a
	call drawstring
	ld d, $22
	call drawstring
	ld d, $2a
	call drawstring
	ld de, $3501
	call drawstring
	ld b, 5
	ld hl, highscoretable
	ld de, $0a10
dhsloop:
	push bc
	push de
	push hl
	call drawstring
	ld e, $60
	ld c, (hl)
	inc hl
	ld b, (hl)
	push bc
	pop hl
	call drawnumber
	pop hl
	ld de, 11
	add hl, de
	pop de
	ld a, d
	add a, 8
	ld d, a
	pop bc
	djnz dhsloop
	ret

changename:
	ld (tempvar), hl
	ld (highpos), hl
	ld b, 8
cnamelp2
	ld (hl), ' '
	inc hl
	djnz cnamelp2
cnameloop:
	call drawhighscores
getkey
	call _getky
	or a
	jr z, getkey
	cp K_DEL
	jr z, deletehighscore
	cp K_EXIT
	ret z
	cp K_SECOND
	ret z
	dec a
	ld e, a
	ld d, 0
	ld hl, stringinputmatrix
	add hl, de
	ld a, (hl)
	ld hl, (tempvar)
	ld (hl), a
	inc hl
	ld a, (hl)
	or a
	jr z, cnameloop
	ld (tempvar), hl
	jr cnameloop
deletehighscore
	ld hl, (tempvar)
	ld a, (highpos)
	cp l
	jr z, getkey
	ld (hl), ' '
	dec hl
	ld (hl), ' '
	ld (tempvar), hl
	jr cnameloop

viewacknowledgements:
	call clearscreen
	ld hl, acstring
	ld de, $0101
	call drawstring
	ld d, 7
	call drawstring
	ld d, 13
	call drawstring
	ld d, 19
	call drawstring
	ld d, 25
	call drawstring
	ld d, 31
	call drawstring
	ld d, 37
	call drawstring
	ld d, 43
	call drawstring
	ld d, 49
	call drawstring
	ld d, 55
	call drawstring
	jp pause

#include galactixdata.asm
#include galactixgfx.asm
#include subroutes.asm

name
	.db 8, "Galactix"

.end
